// Generated by LiveScript 1.2.0
/** ^
 * Copyright (c) 2013 Quildreen Motta
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation files
 * (the "Software"), to deal in the Software without restriction,
 * including without limitation the rights to use, copy, modify, merge,
 * publish, distribute, sublicense, and/or sell copies of the Software,
 * and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
(function(){
  var memoisedFork, id, RejectedFutureExtractionError, Future;
  memoisedFork = function(f, future){
    var pending, started, resolved, rejected, fold;
    pending = [];
    started = false;
    resolved = false;
    rejected = false;
    return fold = function(g, h){
      var started;
      switch (false) {
      case !resolved:
        return h(future.value);
      case !rejected:
        return g(future.value);
      case !started:
        pending.push({
          rejected: g,
          resolved: h
        });
        break;
      default:
        started = true;
        return f(function(a){
          future.isPending = false;
          future.isRejected = rejected = true;
          future.value = a;
          invokePending('rejected', a);
          return g(a);
        }, function(b){
          future.isPending = false;
          future.isResolved = resolved = true;
          future.value = b;
          invokePending('resolved', b);
          return h(b);
        });
      }
    };
    function invokePending(kind, value){
      var xs, i$, len$, x, results$ = [];
      xs = pending;
      started = false;
      pending.length = 0;
      for (i$ = 0, len$ = xs.length; i$ < len$; ++i$) {
        x = xs[i$];
        results$.push(x[kind](value));
      }
      return results$;
    }
    return invokePending;
  };
  id = function(a){
    return a;
  };
  RejectedFutureExtractionError = (function(superclass){
    var prototype = extend$((import$(RejectedFutureExtractionError, superclass).displayName = 'RejectedFutureExtractionError', RejectedFutureExtractionError), superclass).prototype, constructor = RejectedFutureExtractionError;
    function RejectedFutureExtractionError(){
      RejectedFutureExtractionError.superclass.call(this, "Can't extract the value of a rejected future.");
    }
    return RejectedFutureExtractionError;
  }(TypeError));
  Future = (function(){
    Future.displayName = 'Future';
    var prototype = Future.prototype, constructor = Future;
    function Future(f){
      this.fork = memoisedFork(f, this);
    }
    prototype.isPending = true;
    prototype.isResolved = false;
    prototype.isRejected = false;
    Future.of = function(b){
      return new Future(function(reject, resolve){
        return resolve(b);
      });
    };
    prototype.of = function(b){
      return Future.of(b);
    };
    prototype.ap = function(b){
      return this.chain(function(f){
        return b.map(f);
      });
    };
    prototype.map = function(f){
      return this.chain(function(a){
        return Future.of(f(a));
      });
    };
    prototype.chain = function(f){
      var this$ = this;
      return new Future(function(reject, resolve){
        return this$.fork(function(a){
          return reject(a);
        }, function(b){
          return f(b).fork(reject, resolve);
        });
      });
    };
    prototype.toString = function(){
      switch (false) {
      case !this.isPending:
        return "Future.Pending";
      case !this.isResolved:
        return "Future.Resolved(" + this.value + ")";
      case !this.isRejected:
        return "Future.Rejected(" + this.value + ")";
      }
    };
    prototype.isEqual = function(a){
      return Boolean((function(){
        switch (false) {
        case !this.isResolved:
          return a.isResolved && a.value === this.value;
        case !this.isRejected:
          return a.isRejected && a.value === this.value;
        case !this.isPending:
          return this.fork(function(e){
            return a.fork(function(e2){
              return e === e2;
            }, function(_){
              return false;
            });
          }, function(s){
            return a.fork(function(_){
              return false;
            }, function(s2){
              return s === s2;
            });
          });
        }
      }.call(this)));
    };
    prototype.orElse = function(f){
      var this$ = this;
      return new Future(function(reject, resolve){
        return this$.fork(function(a){
          return f(a).fork(reject, resolve);
        }, function(b){
          return resolve(b);
        });
      });
    };
    prototype.fold = curry$(function(f, g){
      var this$ = this;
      return new Future(function(reject, resolve){
        return this$.fork(function(a){
          return resolve(f(a));
        }, function(b){
          return resolve(g(b));
        });
      });
    });
    prototype.swap = function(){
      var this$ = this;
      return new Future(function(reject, resolve){
        return this$.fork(function(a){
          return resolve(a);
        }, function(b){
          return reject(b);
        });
      });
    };
    prototype.bimap = curry$(function(f, g){
      var this$ = this;
      return new Future(function(reject, resolve){
        return this$.fork(function(a){
          return reject(f(a));
        }, function(b){
          return resolve(g(b));
        });
      });
    });
    prototype.rejectedMap = function(f){
      var this$ = this;
      return new Future(function(reject, resolve){
        return this$.fork(function(a){
          return reject(f(a));
        }, function(b){
          return resolve(b);
        });
      });
    };
    return Future;
  }());
  module.exports = Future;
  function extend$(sub, sup){
    function fun(){} fun.prototype = (sub.superclass = sup).prototype;
    (sub.prototype = new fun).constructor = sub;
    if (typeof sup.extended == 'function') sup.extended(sub);
    return sub;
  }
  function import$(obj, src){
    var own = {}.hasOwnProperty;
    for (var key in src) if (own.call(src, key)) obj[key] = src[key];
    return obj;
  }
  function curry$(f, bound){
    var context,
    _curry = function(args) {
      return f.length > 1 ? function(){
        var params = args ? args.concat() : [];
        context = bound ? context || this : this;
        return params.push.apply(params, arguments) <
            f.length && arguments.length ?
          _curry.call(context, params) : f.apply(context, params);
      } : f;
    };
    return _curry();
  }
}).call(this);
